diff -dcrpN postgresql.orig/src/backend/commands/analyze.c postgresql/src/backend/commands/analyze.c
*** postgresql.orig/src/backend/commands/analyze.c	2011-09-12 09:54:31.169314275 +0200
--- postgresql/src/backend/commands/analyze.c	2011-09-13 11:15:14.977046160 +0200
*************** examine_attribute(Relation onerel, int a
*** 834,887 ****
  	 * not a problem.)	It's not clear whether anyone will care about the
  	 * typmod, but we store that too just in case.
  	 */
! 	if (index_expr)
! 	{
! 		stats->attrtypid = exprType(index_expr);
! 		stats->attrtypmod = exprTypmod(index_expr);
! 	}
! 	else
  	{
! 		stats->attrtypid = attr->atttypid;
! 		stats->attrtypmod = attr->atttypmod;
  	}
  
- 	typtuple = SearchSysCacheCopy1(TYPEOID,
- 								   ObjectIdGetDatum(stats->attrtypid));
- 	if (!HeapTupleIsValid(typtuple))
- 		elog(ERROR, "cache lookup failed for type %u", stats->attrtypid);
- 	stats->attrtype = (Form_pg_type) GETSTRUCT(typtuple);
  	stats->anl_context = anl_context;
- 	stats->tupattnum = attnum;
  
  	/*
  	 * The fields describing the stats->stavalues[n] element types default to
  	 * the type of the data being analyzed, but the type-specific typanalyze
  	 * function can change them if it wants to store something else.
  	 */
! 	for (i = 0; i < STATISTIC_NUM_SLOTS; i++)
  	{
! 		stats->statypid[i] = stats->attrtypid;
! 		stats->statyplen[i] = stats->attrtype->typlen;
! 		stats->statypbyval[i] = stats->attrtype->typbyval;
! 		stats->statypalign[i] = stats->attrtype->typalign;
  	}
  
  	/*
! 	 * Call the type-specific typanalyze function.	If none is specified, use
! 	 * std_typanalyze().
  	 */
! 	if (OidIsValid(stats->attrtype->typanalyze))
! 		ok = DatumGetBool(OidFunctionCall1(stats->attrtype->typanalyze,
! 										   PointerGetDatum(stats)));
! 	else
! 		ok = std_typanalyze(stats);
! 
! 	if (!ok || stats->compute_stats == NULL || stats->minrows <= 0)
  	{
! 		heap_freetuple(typtuple);
! 		pfree(stats->attr);
! 		pfree(stats);
! 		return NULL;
  	}
  
  	return stats;
--- 1079,1164 ----
  	 * not a problem.)	It's not clear whether anyone will care about the
  	 * typmod, but we store that too just in case.
  	 */
! 
! 	for (i = 0; i < attnums->dim1; i++)
  	{
! 		if (index_exprs && index_exprs[i])
! 		{
! 			stats->attrtypids[i] = exprType(index_exprs[i]);
! 			stats->attrtypmods[i] = exprTypmod(index_exprs[i]);
! 		}
! 		else
! 		{
! 			stats->attrtypids[i] = stats->attrs[i]->atttypid;
! 			stats->attrtypmods[i] = stats->attrs[i]->atttypmod;
! 		}
! 
! 		typtuple = SearchSysCacheCopy1(TYPEOID,
! 									   ObjectIdGetDatum(stats->attrtypids[i]));
! 		if (!HeapTupleIsValid(typtuple))
! 			elog(ERROR, "cache lookup failed for type %u", stats->attrtypids[i]);
! 		stats->attrtypes[i] = (Form_pg_type) GETSTRUCT(typtuple);
  	}
  
  	stats->anl_context = anl_context;
  
  	/*
  	 * The fields describing the stats->stavalues[n] element types default to
  	 * the type of the data being analyzed, but the type-specific typanalyze
  	 * function can change them if it wants to store something else.
  	 */
! 	for (i = 0; i < attnums->dim1; i++)
  	{
! 		for (j = 0; j < STATISTIC_NUM_SLOTS; j++)
! 		{
! 			stats->statypid[i][j] = stats->attrtypids[i];
! 			stats->statyplen[i][j] = stats->attrtypes[i]->typlen;
! 			stats->statypbyval[i][j] = stats->attrtypes[i]->typbyval;
! 			stats->statypalign[i][j] = stats->attrtypes[i]->typalign;
! 		}
! 
! 		/*
! 		 * Call the type-specific typanalyze function.	If none is specified, use
! 		 * std_typanalyze().
! 		 */
! 		if (OidIsValid(stats->attrtypes[i]->typanalyze))
! 			ok = DatumGetBool(OidFunctionCall2(stats->attrtypes[i]->typanalyze,
! 										   PointerGetDatum(stats),
! 										   Int32GetDatum(i)));
! 		else
! 			ok = std_typanalyze(stats, i);
! 
! 		if (!ok ||
! 			stats->statfuncs[i].compute_func_ptr == NULL ||
! 			/* intentionally don't check stats->statfuncs[i].findval_func_ptr == NULL */
! 			stats->minrows <= 0)
! 		{
! 			for (; i >= 0; i--)
! 			{
! 				heap_freetuple((HeapTuple) stats->attrtypes[i]);
! 				pfree(stats->attrs[i]);
! 			}
! 			pfree(stats);
! 
! 			return NULL;
! 		}
  	}
  
  	/*
! 	 * If we have a cross-column statistics, compute the cube size for
! 	 * the histogram so pg_statistic.statarget really means the number of
! 	 * cells in the multi-dimensional cube.
  	 */
! 	if (stats->attnums->dim1 > 1)
  	{
! 		double		x, y, n;
! 
! 		y = stats->statarget;
! 		n = stats->attnums->dim1;
! 		x = pow(M_E, (log(y) / n));
! 
! 		/* On some systems, ceil() returns surprising result. */
! 		stats->statarget = trunc(x + 0.5);
  	}
  
  	return stats;
*************** acquire_inherited_sample_rows(Relation o
*** 1555,1561 ****
   *		by taking a self-exclusive lock on the relation in analyze_rel().
   */
  static void
! update_attstats(Oid relid, bool inh, int natts, VacAttrStats **vacattrstats)
  {
  	Relation	sd;
  	int			attno;
--- 1832,1838 ----
   *		by taking a self-exclusive lock on the relation in analyze_rel().
   */
  static void
! update_attstats(Oid relid, bool inh, int natts, VacStats **vacstats)
  {
  	Relation	sd;
  	int			attno;
*************** update_attstats(Oid relid, bool inh, int
*** 1567,1573 ****
  
  	for (attno = 0; attno < natts; attno++)
  	{
! 		VacAttrStats *stats = vacattrstats[attno];
  		HeapTuple	stup,
  					oldtup;
  		int			i,
--- 1844,1850 ----
  
  	for (attno = 0; attno < natts; attno++)
  	{
! 		VacStats *stats = vacstats[attno];
  		HeapTuple	stup,
  					oldtup;
  		int			i,
*************** update_attstats(Oid relid, bool inh, int
*** 1590,1615 ****
  			replaces[i] = true;
  		}
  
  		values[Anum_pg_statistic_starelid - 1] = ObjectIdGetDatum(relid);
- 		values[Anum_pg_statistic_staattnum - 1] = Int16GetDatum(stats->attr->attnum);
  		values[Anum_pg_statistic_stainherit - 1] = BoolGetDatum(inh);
! 		values[Anum_pg_statistic_stanullfrac - 1] = Float4GetDatum(stats->stanullfrac);
! 		values[Anum_pg_statistic_stawidth - 1] = Int32GetDatum(stats->stawidth);
! 		values[Anum_pg_statistic_stadistinct - 1] = Float4GetDatum(stats->stadistinct);
  		i = Anum_pg_statistic_stakind1 - 1;
  		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
  		{
! 			values[i++] = Int16GetDatum(stats->stakind[k]);		/* stakindN */
  		}
  		i = Anum_pg_statistic_staop1 - 1;
  		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
  		{
! 			values[i++] = ObjectIdGetDatum(stats->staop[k]);	/* staopN */
  		}
  		i = Anum_pg_statistic_stanumbers1 - 1;
  		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
  		{
! 			int			nnum = stats->numnumbers[k];
  
  			if (nnum > 0)
  			{
--- 1867,1901 ----
  			replaces[i] = true;
  		}
  
+ 		/*
+ 		 * We use statarget = -1 here, so if the pg_statistic entry is new,
+ 		 * we use the default_statistics_target for it. If there's a pg_statistic
+ 		 * row for this statistics, we will set the "replaces" flag to false.
+ 		 */
+ 		values[Anum_pg_statistic_statarget - 1] = Int32GetDatum(-1);
  		values[Anum_pg_statistic_starelid - 1] = ObjectIdGetDatum(relid);
  		values[Anum_pg_statistic_stainherit - 1] = BoolGetDatum(inh);
! 		values[Anum_pg_statistic_stavalid - 1] = BoolGetDatum(true);
! 		values[Anum_pg_statistic_stanullfrac - 1] = Float4GetDatum(stats->stanullfrac[0]);
! 		values[Anum_pg_statistic_stawidth - 1] = Int32GetDatum(stats->stawidth[0]);
! 		values[Anum_pg_statistic_stadistinct - 1] = Float4GetDatum(stats->stadistinct[0]);
  		i = Anum_pg_statistic_stakind1 - 1;
  		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
  		{
! 			values[i++] = Int16GetDatum(stats->stakind[0][k]);	/* stakindN */
  		}
  		i = Anum_pg_statistic_staop1 - 1;
  		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
  		{
! 			values[i++] = ObjectIdGetDatum(stats->staop[0][k]);	/* staopN */
  		}
+ 
+ 		values[Anum_pg_statistic_staattnums - 1] = PointerGetDatum(stats->attnums);	/* staattnums */
+ 
  		i = Anum_pg_statistic_stanumbers1 - 1;
  		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
  		{
! 			int			nnum = stats->numnumbers[0][k];
  
  			if (nnum > 0)
  			{
*************** update_attstats(Oid relid, bool inh, int
*** 1617,1623 ****
  				ArrayType  *arry;
  
  				for (n = 0; n < nnum; n++)
! 					numdatums[n] = Float4GetDatum(stats->stanumbers[k][n]);
  				/* XXX knows more than it should about type float4: */
  				arry = construct_array(numdatums, nnum,
  									   FLOAT4OID,
--- 1903,1909 ----
  				ArrayType  *arry;
  
  				for (n = 0; n < nnum; n++)
! 					numdatums[n] = Float4GetDatum(stats->stanumbers[0][k][n]);
  				/* XXX knows more than it should about type float4: */
  				arry = construct_array(numdatums, nnum,
  									   FLOAT4OID,
*************** update_attstats(Oid relid, bool inh, int
*** 1633,1648 ****
  		i = Anum_pg_statistic_stavalues1 - 1;
  		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
  		{
! 			if (stats->numvalues[k] > 0)
  			{
  				ArrayType  *arry;
  
! 				arry = construct_array(stats->stavalues[k],
! 									   stats->numvalues[k],
! 									   stats->statypid[k],
! 									   stats->statyplen[k],
! 									   stats->statypbyval[k],
! 									   stats->statypalign[k]);
  				values[i++] = PointerGetDatum(arry);	/* stavaluesN */
  			}
  			else
--- 1919,1947 ----
  		i = Anum_pg_statistic_stavalues1 - 1;
  		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
  		{
! 			int	idx1, idx2;
! 
! 			if (stats->attnums->dim1 > 1 && k < stats->attnums->dim1)
! 			{
! 				idx1 = k;
! 				idx2 = 0;
! 			}
! 			else
! 			{
! 				idx1 = 0;
! 				idx2 = k;
! 			}
! 
! 			if (stats->numvalues[idx1][idx2] > 0)
  			{
  				ArrayType  *arry;
  
! 				arry = construct_array(stats->stavalues[idx1][idx2],
! 									   stats->numvalues[idx1][idx2],
! 									   stats->statypid[idx1][idx2],
! 									   stats->statyplen[idx1][idx2],
! 									   stats->statypbyval[idx1][idx2],
! 									   stats->statypalign[idx1][idx2]);
  				values[i++] = PointerGetDatum(arry);	/* stavaluesN */
  			}
  			else
*************** update_attstats(Oid relid, bool inh, int
*** 1655,1665 ****
  		/* Is there already a pg_statistic tuple for this attribute? */
  		oldtup = SearchSysCache3(STATRELATTINH,
  								 ObjectIdGetDatum(relid),
! 								 Int16GetDatum(stats->attr->attnum),
  								 BoolGetDatum(inh));
  
  		if (HeapTupleIsValid(oldtup))
  		{
  			/* Yes, replace it */
  			stup = heap_modify_tuple(oldtup,
  									 RelationGetDescr(sd),
--- 1954,1967 ----
  		/* Is there already a pg_statistic tuple for this attribute? */
  		oldtup = SearchSysCache3(STATRELATTINH,
  								 ObjectIdGetDatum(relid),
! 								 PointerGetDatum(stats->attnums),
  								 BoolGetDatum(inh));
  
  		if (HeapTupleIsValid(oldtup))
  		{
+ 			/* Skip replacing the statarget value, so we remember its value. */
+ 			replaces[Anum_pg_statistic_statarget - 1] = false;
+ 
  			/* Yes, replace it */
  			stup = heap_modify_tuple(oldtup,
  									 RelationGetDescr(sd),
*************** update_attstats(Oid relid, bool inh, int
*** 1692,1704 ****
   * and the actual storage of the sample data.
   */
  static Datum
! std_fetch_func(VacAttrStatsP stats, int rownum, bool *isNull)
  {
- 	int			attnum = stats->tupattnum;
  	HeapTuple	tuple = stats->rows[rownum];
  	TupleDesc	tupDesc = stats->tupDesc;
  
! 	return heap_getattr(tuple, attnum, tupDesc, isNull);
  }
  
  /*
--- 1994,2005 ----
   * and the actual storage of the sample data.
   */
  static Datum
! std_fetch_func(VacStatsP stats, int rownum, AttrNumber tupattnum, bool *isNull)
  {
  	HeapTuple	tuple = stats->rows[rownum];
  	TupleDesc	tupDesc = stats->tupDesc;
  
! 	return heap_getattr(tuple, tupattnum, tupDesc, isNull);
  }
  
  /*
*************** std_fetch_func(VacAttrStatsP stats, int 
*** 1708,1719 ****
   * just in Datum arrays.
   */
  static Datum
! ind_fetch_func(VacAttrStatsP stats, int rownum, bool *isNull)
  {
  	int			i;
  
! 	/* exprvals and exprnulls are already offset for proper column */
! 	i = rownum * stats->rowstride;
  	*isNull = stats->exprnulls[i];
  	return stats->exprvals[i];
  }
--- 2009,2019 ----
   * just in Datum arrays.
   */
  static Datum
! ind_fetch_func(VacStatsP stats, int rownum, AttrNumber tupattnum, bool *isNull)
  {
  	int			i;
  
! 	i = rownum * stats->rowstride + tupattnum - 1;
  	*isNull = stats->exprnulls[i];
  	return stats->exprvals[i];
  }
*************** typedef struct
*** 1772,1783 ****
  	int		   *tupnoLink;
  } CompareScalarsContext;
  
  
! static void compute_minimal_stats(VacAttrStatsP stats,
  					  AnalyzeAttrFetchFunc fetchfunc,
  					  int samplerows,
  					  double totalrows);
! static void compute_scalar_stats(VacAttrStatsP stats,
  					 AnalyzeAttrFetchFunc fetchfunc,
  					 int samplerows,
  					 double totalrows);
--- 2072,2090 ----
  	int		   *tupnoLink;
  } CompareScalarsContext;
  
+ typedef struct
+ {
+ 	FmgrInfo		cmpFn;
+ 	int			cmpFlags;
+ } CompareDatumsContext;
  
! static void compute_minimal_stats(VacStatsP stats,
! 					  int index,
  					  AnalyzeAttrFetchFunc fetchfunc,
  					  int samplerows,
  					  double totalrows);
! static void compute_scalar_stats(VacStatsP stats,
! 					 int index,
  					 AnalyzeAttrFetchFunc fetchfunc,
  					 int samplerows,
  					 double totalrows);
*************** static int	compare_mcvs(const void *a, c
*** 1789,1808 ****
   * std_typanalyze -- the default type-specific typanalyze function
   */
  static bool
! std_typanalyze(VacAttrStats *stats)
  {
- 	Form_pg_attribute attr = stats->attr;
  	Oid			ltopr;
  	Oid			eqopr;
  	StdAnalyzeData *mystats;
  
! 	/* If the attstattarget column is negative, use the default value */
  	/* NB: it is okay to scribble on stats->attr since it's a copy */
! 	if (attr->attstattarget < 0)
! 		attr->attstattarget = default_statistics_target;
  
  	/* Look for default "<" and "=" operators for column's type */
! 	get_sort_group_operators(stats->attrtypid,
  							 false, false, false,
  							 &ltopr, &eqopr, NULL,
  							 NULL);
--- 2096,2114 ----
   * std_typanalyze -- the default type-specific typanalyze function
   */
  static bool
! std_typanalyze(VacStats *stats, int index)
  {
  	Oid			ltopr;
  	Oid			eqopr;
  	StdAnalyzeData *mystats;
  
! 	/* If the statarget column is negative, use the default value */
  	/* NB: it is okay to scribble on stats->attr since it's a copy */
! 	if (stats->statarget < 0)
! 		stats->statarget = default_statistics_target;
  
  	/* Look for default "<" and "=" operators for column's type */
! 	get_sort_group_operators(stats->attrtypids[index],
  							 false, false, false,
  							 &ltopr, &eqopr, NULL,
  							 NULL);
*************** std_typanalyze(VacAttrStats *stats)
*** 1816,1822 ****
  	mystats->eqopr = eqopr;
  	mystats->eqfunc = get_opcode(eqopr);
  	mystats->ltopr = ltopr;
! 	stats->extra_data = mystats;
  
  	/*
  	 * Determine which standard statistics algorithm to use
--- 2122,2128 ----
  	mystats->eqopr = eqopr;
  	mystats->eqfunc = get_opcode(eqopr);
  	mystats->ltopr = ltopr;
! 	stats->extra_data[index] = mystats;
  
  	/*
  	 * Determine which standard statistics algorithm to use
*************** std_typanalyze(VacAttrStats *stats)
*** 1824,1830 ****
  	if (OidIsValid(ltopr))
  	{
  		/* Seems to be a scalar datatype */
! 		stats->compute_stats = compute_scalar_stats;
  		/*--------------------
  		 * The following choice of minrows is based on the paper
  		 * "Random sampling for histogram construction: how much is enough?"
--- 2130,2137 ----
  	if (OidIsValid(ltopr))
  	{
  		/* Seems to be a scalar datatype */
! 		stats->statfuncs[index].compute_func_ptr = compute_scalar_stats;
! 		stats->statfuncs[index].findval_func_ptr = ordered_findval;
  		/*--------------------
  		 * The following choice of minrows is based on the paper
  		 * "Random sampling for histogram construction: how much is enough?"
*************** std_typanalyze(VacAttrStats *stats)
*** 1844,1857 ****
  		 * know it at this point.
  		 *--------------------
  		 */
! 		stats->minrows = 300 * attr->attstattarget;
  	}
  	else
  	{
  		/* Can't do much but the minimal stuff */
! 		stats->compute_stats = compute_minimal_stats;
  		/* Might as well use the same minrows as above */
! 		stats->minrows = 300 * attr->attstattarget;
  	}
  
  	return true;
--- 2151,2165 ----
  		 * know it at this point.
  		 *--------------------
  		 */
! 		stats->minrows = 300 * stats->statarget;
  	}
  	else
  	{
  		/* Can't do much but the minimal stuff */
! 		stats->statfuncs[index].compute_func_ptr = compute_minimal_stats;
! 		stats->statfuncs[index].findval_func_ptr = unordered_findval;
  		/* Might as well use the same minrows as above */
! 		stats->minrows = 300 * stats->statarget;
  	}
  
  	return true;
*************** std_typanalyze(VacAttrStats *stats)
*** 1873,1879 ****
   *	depend mainly on the length of the list we are willing to keep.
   */
  static void
! compute_minimal_stats(VacAttrStatsP stats,
  					  AnalyzeAttrFetchFunc fetchfunc,
  					  int samplerows,
  					  double totalrows)
--- 2181,2188 ----
   *	depend mainly on the length of the list we are willing to keep.
   */
  static void
! compute_minimal_stats(VacStatsP stats,
! 					  int index,
  					  AnalyzeAttrFetchFunc fetchfunc,
  					  int samplerows,
  					  double totalrows)
*************** compute_minimal_stats(VacAttrStatsP stat
*** 1883,1892 ****
  	int			nonnull_cnt = 0;
  	int			toowide_cnt = 0;
  	double		total_width = 0;
! 	bool		is_varlena = (!stats->attrtype->typbyval &&
! 							  stats->attrtype->typlen == -1);
! 	bool		is_varwidth = (!stats->attrtype->typbyval &&
! 							   stats->attrtype->typlen < 0);
  	FmgrInfo	f_cmpeq;
  	typedef struct
  	{
--- 2192,2201 ----
  	int			nonnull_cnt = 0;
  	int			toowide_cnt = 0;
  	double		total_width = 0;
! 	bool		is_varlena = (!stats->attrtypes[index]->typbyval &&
! 							  stats->attrtypes[index]->typlen == -1);
! 	bool		is_varwidth = (!stats->attrtypes[index]->typbyval &&
! 							   stats->attrtypes[index]->typlen < 0);
  	FmgrInfo	f_cmpeq;
  	typedef struct
  	{
*************** compute_minimal_stats(VacAttrStatsP stat
*** 1896,1903 ****
  	TrackItem  *track;
  	int			track_cnt,
  				track_max;
! 	int			num_mcv = stats->attr->attstattarget;
! 	StdAnalyzeData *mystats = (StdAnalyzeData *) stats->extra_data;
  
  	/*
  	 * We track up to 2*n values for an n-element MCV list; but at least 10
--- 2205,2212 ----
  	TrackItem  *track;
  	int			track_cnt,
  				track_max;
! 	int			num_mcv = stats->statarget;
! 	StdAnalyzeData *mystats = (StdAnalyzeData *) stats->extra_data[index];
  
  	/*
  	 * We track up to 2*n values for an n-element MCV list; but at least 10
*************** compute_minimal_stats(VacAttrStatsP stat
*** 1920,1926 ****
  
  		vacuum_delay_point();
  
! 		value = fetchfunc(stats, i, &isnull);
  
  		/* Check for null/nonnull */
  		if (isnull)
--- 2229,2235 ----
  
  		vacuum_delay_point();
  
! 		value = fetchfunc(stats, i, stats->attnums->values[index], &isnull);
  
  		/* Check for null/nonnull */
  		if (isnull)
*************** compute_minimal_stats(VacAttrStatsP stat
*** 2017,2027 ****
  
  		stats->stats_valid = true;
  		/* Do the simple null-frac and width stats */
! 		stats->stanullfrac = (double) null_cnt / (double) samplerows;
  		if (is_varwidth)
! 			stats->stawidth = total_width / (double) nonnull_cnt;
  		else
! 			stats->stawidth = stats->attrtype->typlen;
  
  		/* Count the number of values we found multiple times */
  		summultiple = 0;
--- 2326,2336 ----
  
  		stats->stats_valid = true;
  		/* Do the simple null-frac and width stats */
! 		stats->stanullfrac[index] = (double) null_cnt / (double) samplerows;
  		if (is_varwidth)
! 			stats->stawidth[index] = total_width / (double) nonnull_cnt;
  		else
! 			stats->stawidth[index] = stats->attrtypes[index]->typlen;
  
  		/* Count the number of values we found multiple times */
  		summultiple = 0;
*************** compute_minimal_stats(VacAttrStatsP stat
*** 2035,2041 ****
  		if (nmultiple == 0)
  		{
  			/* If we found no repeated values, assume it's a unique column */
! 			stats->stadistinct = -1.0;
  		}
  		else if (track_cnt < track_max && toowide_cnt == 0 &&
  				 nmultiple == track_cnt)
--- 2344,2350 ----
  		if (nmultiple == 0)
  		{
  			/* If we found no repeated values, assume it's a unique column */
! 			stats->stadistinct[index] = -1.0;
  		}
  		else if (track_cnt < track_max && toowide_cnt == 0 &&
  				 nmultiple == track_cnt)
*************** compute_minimal_stats(VacAttrStatsP stat
*** 2045,2051 ****
  			 * value appeared more than once.  Assume the column has just
  			 * these values.
  			 */
! 			stats->stadistinct = track_cnt;
  		}
  		else
  		{
--- 2354,2360 ----
  			 * value appeared more than once.  Assume the column has just
  			 * these values.
  			 */
! 			stats->stadistinct[index] = track_cnt;
  		}
  		else
  		{
*************** compute_minimal_stats(VacAttrStatsP stat
*** 2084,2090 ****
  				stadistinct = (double) d;
  			if (stadistinct > totalrows)
  				stadistinct = totalrows;
! 			stats->stadistinct = floor(stadistinct + 0.5);
  		}
  
  		/*
--- 2393,2399 ----
  				stadistinct = (double) d;
  			if (stadistinct > totalrows)
  				stadistinct = totalrows;
! 			stats->stadistinct[index] = floor(stadistinct + 0.5);
  		}
  
  		/*
*************** compute_minimal_stats(VacAttrStatsP stat
*** 2093,2100 ****
  		 * stadistinct should scale with the row count rather than be a fixed
  		 * value.
  		 */
! 		if (stats->stadistinct > 0.1 * totalrows)
! 			stats->stadistinct = -(stats->stadistinct / totalrows);
  
  		/*
  		 * Decide how many values are worth storing as most-common values. If
--- 2402,2409 ----
  		 * stadistinct should scale with the row count rather than be a fixed
  		 * value.
  		 */
! 		if (stats->stadistinct[index] > 0.1 * totalrows)
! 			stats->stadistinct[index] = -(stats->stadistinct[index] / totalrows);
  
  		/*
  		 * Decide how many values are worth storing as most-common values. If
*************** compute_minimal_stats(VacAttrStatsP stat
*** 2114,2120 ****
  		}
  		else
  		{
! 			double		ndistinct = stats->stadistinct;
  			double		avgcount,
  						mincount;
  
--- 2423,2429 ----
  		}
  		else
  		{
! 			double		ndistinct = stats->stadistinct[index];
  			double		avgcount,
  						mincount;
  
*************** compute_minimal_stats(VacAttrStatsP stat
*** 2152,2169 ****
  			for (i = 0; i < num_mcv; i++)
  			{
  				mcv_values[i] = datumCopy(track[i].value,
! 										  stats->attrtype->typbyval,
! 										  stats->attrtype->typlen);
  				mcv_freqs[i] = (double) track[i].count / (double) samplerows;
  			}
  			MemoryContextSwitchTo(old_context);
  
! 			stats->stakind[0] = STATISTIC_KIND_MCV;
! 			stats->staop[0] = mystats->eqopr;
! 			stats->stanumbers[0] = mcv_freqs;
! 			stats->numnumbers[0] = num_mcv;
! 			stats->stavalues[0] = mcv_values;
! 			stats->numvalues[0] = num_mcv;
  
  			/*
  			 * Accept the defaults for stats->statypid and others. They have
--- 2461,2478 ----
  			for (i = 0; i < num_mcv; i++)
  			{
  				mcv_values[i] = datumCopy(track[i].value,
! 										  stats->attrtypes[index]->typbyval,
! 										  stats->attrtypes[index]->typlen);
  				mcv_freqs[i] = (double) track[i].count / (double) samplerows;
  			}
  			MemoryContextSwitchTo(old_context);
  
! 			stats->stakind[index][0] = STATISTIC_KIND_MCV;
! 			stats->staop[index][0] = mystats->eqopr;
! 			stats->stanumbers[index][0] = mcv_freqs;
! 			stats->numnumbers[index][0] = num_mcv;
! 			stats->stavalues[index][0] = mcv_values;
! 			stats->numvalues[index][0] = num_mcv;
  
  			/*
  			 * Accept the defaults for stats->statypid and others. They have
*************** compute_minimal_stats(VacAttrStatsP stat
*** 2175,2186 ****
  	{
  		/* We found only nulls; assume the column is entirely null */
  		stats->stats_valid = true;
! 		stats->stanullfrac = 1.0;
  		if (is_varwidth)
! 			stats->stawidth = 0;	/* "unknown" */
  		else
! 			stats->stawidth = stats->attrtype->typlen;
! 		stats->stadistinct = 0.0;		/* "unknown" */
  	}
  
  	/* We don't need to bother cleaning up any of our temporary palloc's */
--- 2484,2495 ----
  	{
  		/* We found only nulls; assume the column is entirely null */
  		stats->stats_valid = true;
! 		stats->stanullfrac[index] = 1.0;
  		if (is_varwidth)
! 			stats->stawidth[index] = 0;	/* "unknown" */
  		else
! 			stats->stawidth[index] = stats->attrtypes[index]->typlen;
! 		stats->stadistinct[index] = 0.0;	/* "unknown" */
  	}
  
  	/* We don't need to bother cleaning up any of our temporary palloc's */
*************** compute_minimal_stats(VacAttrStatsP stat
*** 2200,2206 ****
   *	data values into order.
   */
  static void
! compute_scalar_stats(VacAttrStatsP stats,
  					 AnalyzeAttrFetchFunc fetchfunc,
  					 int samplerows,
  					 double totalrows)
--- 2509,2516 ----
   *	data values into order.
   */
  static void
! compute_scalar_stats(VacStatsP stats,
! 					 int index,
  					 AnalyzeAttrFetchFunc fetchfunc,
  					 int samplerows,
  					 double totalrows)
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2210,2219 ****
  	int			nonnull_cnt = 0;
  	int			toowide_cnt = 0;
  	double		total_width = 0;
! 	bool		is_varlena = (!stats->attrtype->typbyval &&
! 							  stats->attrtype->typlen == -1);
! 	bool		is_varwidth = (!stats->attrtype->typbyval &&
! 							   stats->attrtype->typlen < 0);
  	double		corr_xysum;
  	Oid			cmpFn;
  	int			cmpFlags;
--- 2520,2529 ----
  	int			nonnull_cnt = 0;
  	int			toowide_cnt = 0;
  	double		total_width = 0;
! 	bool		is_varlena = (!stats->attrtypes[index]->typbyval &&
! 							  stats->attrtypes[index]->typlen == -1);
! 	bool		is_varwidth = (!stats->attrtypes[index]->typbyval &&
! 							   stats->attrtypes[index]->typlen < 0);
  	double		corr_xysum;
  	Oid			cmpFn;
  	int			cmpFlags;
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2223,2231 ****
  	int		   *tupnoLink;
  	ScalarMCVItem *track;
  	int			track_cnt = 0;
! 	int			num_mcv = stats->attr->attstattarget;
! 	int			num_bins = stats->attr->attstattarget;
! 	StdAnalyzeData *mystats = (StdAnalyzeData *) stats->extra_data;
  
  	values = (ScalarItem *) palloc(samplerows * sizeof(ScalarItem));
  	tupnoLink = (int *) palloc(samplerows * sizeof(int));
--- 2533,2541 ----
  	int		   *tupnoLink;
  	ScalarMCVItem *track;
  	int			track_cnt = 0;
! 	int			num_mcv = stats->statarget;
! 	int			num_bins = stats->statarget;
! 	StdAnalyzeData *mystats = (StdAnalyzeData *) stats->extra_data[index];
  
  	values = (ScalarItem *) palloc(samplerows * sizeof(ScalarItem));
  	tupnoLink = (int *) palloc(samplerows * sizeof(int));
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2242,2248 ****
  
  		vacuum_delay_point();
  
! 		value = fetchfunc(stats, i, &isnull);
  
  		/* Check for null/nonnull */
  		if (isnull)
--- 2552,2558 ----
  
  		vacuum_delay_point();
  
! 		value = fetchfunc(stats, i, stats->attnums->values[index], &isnull);
  
  		/* Check for null/nonnull */
  		if (isnull)
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2372,2387 ****
  
  		stats->stats_valid = true;
  		/* Do the simple null-frac and width stats */
! 		stats->stanullfrac = (double) null_cnt / (double) samplerows;
  		if (is_varwidth)
! 			stats->stawidth = total_width / (double) nonnull_cnt;
  		else
! 			stats->stawidth = stats->attrtype->typlen;
  
  		if (nmultiple == 0)
  		{
  			/* If we found no repeated values, assume it's a unique column */
! 			stats->stadistinct = -1.0;
  		}
  		else if (toowide_cnt == 0 && nmultiple == ndistinct)
  		{
--- 2682,2697 ----
  
  		stats->stats_valid = true;
  		/* Do the simple null-frac and width stats */
! 		stats->stanullfrac[index] = (double) null_cnt / (double) samplerows;
  		if (is_varwidth)
! 			stats->stawidth[index] = total_width / (double) nonnull_cnt;
  		else
! 			stats->stawidth[index] = stats->attrtypes[index]->typlen;
  
  		if (nmultiple == 0)
  		{
  			/* If we found no repeated values, assume it's a unique column */
! 			stats->stadistinct[index] = -1.0;
  		}
  		else if (toowide_cnt == 0 && nmultiple == ndistinct)
  		{
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2389,2395 ****
  			 * Every value in the sample appeared more than once.  Assume the
  			 * column has just these values.
  			 */
! 			stats->stadistinct = ndistinct;
  		}
  		else
  		{
--- 2699,2705 ----
  			 * Every value in the sample appeared more than once.  Assume the
  			 * column has just these values.
  			 */
! 			stats->stadistinct[index] = ndistinct;
  		}
  		else
  		{
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2424,2430 ****
  				stadistinct = (double) d;
  			if (stadistinct > totalrows)
  				stadistinct = totalrows;
! 			stats->stadistinct = floor(stadistinct + 0.5);
  		}
  
  		/*
--- 2734,2740 ----
  				stadistinct = (double) d;
  			if (stadistinct > totalrows)
  				stadistinct = totalrows;
! 			stats->stadistinct[index] = floor(stadistinct + 0.5);
  		}
  
  		/*
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2433,2440 ****
  		 * stadistinct should scale with the row count rather than be a fixed
  		 * value.
  		 */
! 		if (stats->stadistinct > 0.1 * totalrows)
! 			stats->stadistinct = -(stats->stadistinct / totalrows);
  
  		/*
  		 * Decide how many values are worth storing as most-common values. If
--- 2743,2750 ----
  		 * stadistinct should scale with the row count rather than be a fixed
  		 * value.
  		 */
! 		if (stats->stadistinct[index] > 0.1 * totalrows)
! 			stats->stadistinct[index] = -(stats->stadistinct[index] / totalrows);
  
  		/*
  		 * Decide how many values are worth storing as most-common values. If
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2451,2457 ****
  		 * but we prefer to treat such values as MCVs if at all possible.)
  		 */
  		if (track_cnt == ndistinct && toowide_cnt == 0 &&
! 			stats->stadistinct > 0 &&
  			track_cnt <= num_mcv)
  		{
  			/* Track list includes all values seen, and all will fit */
--- 2761,2767 ----
  		 * but we prefer to treat such values as MCVs if at all possible.)
  		 */
  		if (track_cnt == ndistinct && toowide_cnt == 0 &&
! 			stats->stadistinct[index] > 0 &&
  			track_cnt <= num_mcv)
  		{
  			/* Track list includes all values seen, and all will fit */
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2459,2465 ****
  		}
  		else
  		{
! 			double		ndistinct = stats->stadistinct;
  			double		avgcount,
  						mincount,
  						maxmincount;
--- 2769,2775 ----
  		}
  		else
  		{
! 			double		ndistinct = stats->stadistinct[index];
  			double		avgcount,
  						mincount,
  						maxmincount;
